## Complex examples

Learning how to work around some limitations and use various advanced features.

### [Report per sheet](SheetReport/Readme.md)

Tags are supported in sheet names. Easy to create report - per sheet(s).

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SheetReport/template/Report.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SheetReport/result.xlsx)

### [Multi-step processing](DoubleProcessing/Readme.md)

Sometimes documents needs to be processed multiple times before final report can be created.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/DoubleProcessing/template/ResizeWithNesting.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/DoubleProcessing/result.xlsx)

### [XML binding](XmlBinding/Readme.md)

Templater also integrates with Word XML binding feature, it will manage bound XML files.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/XmlBinding/template/Binding.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/XmlBinding/result.docx)

### [Simple sales order application](SalesOrderMVP%20(.NET)/Readme.md)

Templater makes it very convenient to manage report templates.

[Sales order Word](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/Templates/SalesOrderItem.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/result-one.docx)

[Sales order Excel](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/Templates/SalesOrderItem.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/result-one.xlsx)

[Sales order analysis](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/Templates/SalesOrderGrid.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/SalesOrderMVP%20(.NET)/result-grid.xlsx)

[Sales order for printing](SalesOrderMVP%20(.NET)/Templates/SalesOrder.txt) - [result](SalesOrderMVP%20(.NET)/result.txt)

### [Complex Excel report](DepartmentReport/Readme.md)

Combining various Excel features to create good-looking report. Using expression parser for filtering.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/DepartmentReport/template/departments.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/DepartmentReport/result.xlsx)

### [Power Query/Get & Transform](PowerQuery/Readme.md)

Consuming embedded CSV or Excel table via Power Query (Requires Excel 2010+)

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/PowerQuery/template/PowerQuery.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Advanced/PowerQuery/result.xlsx)

### [CSV streaming](Streaming/Readme.md)

Stream CSV/XML while processing to support huge exports

[csv template](Streaming/template/input.csv) - [result](Streaming/result.csv)

[xml template](Streaming/template/input.xml) - [result](Streaming/result.xml)

### [Various JSON examples](TemplaterServer/Readme.md)

Application from https://templater.info/demo

### [PDF conversion](TemplaterServer/Readme.md)

PDF conversion via [Dockerfile](TemplaterServer/Dockerfile)
