## Understanding how Templater works

Introduction to basic features and processing rules.

### [Simple document](SimpleDocument/Readme.md)

Replacing a single tag in the document.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimpleDocument/template/MyDocument.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimpleDocument/result.docx)

### [Simple spreadsheet](SimpleSpreadsheet/Readme.md)

Replacing tags in the spreadsheet.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimpleSpreadsheet/template/MySpreadsheet.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimpleSpreadsheet/result.xlsx)

### [Simple presentation](SimplePresentation/Readme.md)

Replacing tags in the presentation.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimplePresentation/template/Presentation.pptx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SimplePresentation/result.pptx)

### [Inserting images](ImageExample/Readme.md)

How to insert an image into a document.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ImageExample/template/Picture.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ImageExample/result.docx)

### [Android](AndroidExample/Readme.md)

Templater also works in Android.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/AndroidExample/app/src/main/res/raw/template.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/AndroidExample/output.docx)

### [License embedding](WebExample%20(.NET)/Readme.md)

How to embed license file (templater.lic) into a web project.

[resource](WebExample%20(.NET)/TemplaterWeb.csproj#L96)

### [Flexible types](MapExample%20(Java)/Readme.md)

Templater supports classes via reflection and more dynamic types such as maps.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/MapExample%20(Java)/src/main/resources/MyMap.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/MapExample%20(Java)/result.docx)

### [Scala specifics](BeerList%20(Scala)/Readme.md)

Templater is written in Scala and supports some Scala specific collections/types.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/BeerList%20(Scala)/src/main/resources/BeerList.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/BeerList%20(Scala)/result.docx)

### [Collections](ListExample/Readme.md)

While simple scenario such as repeating of a table rows is supported, arbitrary nesting is also supported - nesting collection inside a collection inside a collection...

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ListExample/template/MyList.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ListExample/result.docx)

### [Labels](Labels/Readme.md)

Word features, such as columns, can be leveraged for layout. Barcodes from embedded fonts.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/Labels/template/label.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/Labels/result.docx)

### [Paragraphs](Paragraphs/Readme.md)

Resizing of paragraphs can be easily simulated via lists and tables.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/Paragraphs/template/Paragraphs.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/Paragraphs/result.docx)

### [CSV](CsvExample/Readme.md)

CSV output can be used when appropriate.

[template](CsvExample/template/export.csv) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/CsvExample/result.csv)

### [Named range](NamedRange/Readme.md)

In Excel, region fine tuning can be done via named ranges.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/NamedRange/template/Scorecard.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/NamedRange/result.xlsx)

### [Context detection](SpreadsheetGrouping/Readme.md)

Context analysis will work across nested collections.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SpreadsheetGrouping/template/Grouping.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/SpreadsheetGrouping/result.xlsx)

### [Excel links](ExcelLinks/Readme.md)

Various Excel features are supported.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ExcelLinks/template/Links.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ExcelLinks/result.xlsx)

### [PowerPoint tables](PresentationTables/Readme.md)

Populating tables works the same way across formats.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PresentationTables/template/tables.pptx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PresentationTables/result.pptx)

### [Special Word objects](WordLinks/Readme.md)

Various Word features are supported.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/WordLinks/template/Links.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/WordLinks/result.docx)

### [Mail merge](MailMerge/Readme.md)

Inserting pictures via plugins allows for simple templates.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/MailMerge/template/letter.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/MailMerge/result.docx)

### [Pivots](PivotExample/Readme.md)

Integration with complex office features gets the most out of Templater.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PivotExample/template/Pivot.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PivotExample/result.xlsx)

### [Excel pushdown](PushDownExample/Readme.md)

When region extends, stuff needs to be moved around.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PushDownExample/template/MyTable.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/PushDownExample/result.xlsx)

### [.NET DataSet](DataSet%20(.NET)/Readme.md)

Master-detail relationship in DataSet type. Injecting colors via XML type.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/DataSet%20(.NET)/SampleLetter.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/DataSet%20(.NET)/result.docx)

### [Dynamic resize](DynamicResize/Readme.md)

When number of columns is unknown - two dimensional objects can be used.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/DynamicResize/template/GroceryList.docx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/DynamicResize/result.docx)

### [Conversion to formulas](ToFormulaConversion/Readme.md)

Special tag **[[equals]]** is used to convert cells into formulas.

[template](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ToFormulaConversion/template/SimpleConversion.xlsx) - [result](https://github.com/ngs-doo/TemplaterExamples/raw/master/Beginner/ToFormulaConversion/result.xlsx)
